<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="船名" prop="shipName">
        <el-input
          v-model="queryParams.shipName"
          placeholder="请输入船名"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:ship:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:ship:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:ship:remove']"
        >删除</el-button>
      </el-col>
<!--      <el-col :span="1.5">-->
<!--        <el-button-->
<!--          type="warning"-->
<!--          plain-->
<!--          icon="el-icon-download"-->
<!--          size="mini"-->
<!--          @click="handleExport"-->
<!--          v-hasPermi="['system:ship:export']"-->
<!--        >导出</el-button>-->
<!--      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="shipList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="船名" align="center" prop="shipName" />
      <el-table-column label="船型" align="center" prop="shipType" />
      <el-table-column label="船长" align="center" prop="lengthOverall" />
      <el-table-column label="驱动类型" align="center" prop="propulsion" />
      <el-table-column label="船舶注册号" align="center" prop="registrationNumber" />
      <el-table-column label="船舱数量" align="center" prop="quantity" />
      <el-table-column label="乘客容量" align="center" prop="passengerCapacity" />
      <el-table-column label="安全设备" align="center" prop="safetyEquipment" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:ship:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:ship:remove']"
          >删除</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-s-promotion"
            @click="handleJump(scope.row)"
          >查看路线</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改游船对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="船名" prop="shipName">
          <el-input v-model="form.shipName" placeholder="请输入船名" />
        </el-form-item>
        <el-form-item label="船长" prop="lengthOverall">
          <el-input v-model="form.lengthOverall" placeholder="请输入船长" />
        </el-form-item>
        <el-form-item label="船型" prop="shipType">
          <el-input v-model="form.shipType" placeholder="请输入船型" />
        </el-form-item>
        <el-form-item label="驱动类型" prop="propulsion">
          <el-input v-model="form.propulsion" placeholder="请输入驱动类型" />
        </el-form-item>
        <el-form-item label="船舶注册号" prop="registrationNumber">
          <el-input v-model="form.registrationNumber" placeholder="请输入船舶注册号" />
        </el-form-item>
        <el-form-item label="船舱数量" prop="quantity">
          <el-input v-model="form.quantity" placeholder="请输入船舱数量" />
        </el-form-item>
        <el-form-item label="乘客容量" prop="passengerCapacity">
          <el-input v-model="form.passengerCapacity" placeholder="请输入乘客容量" />
        </el-form-item>
        <el-form-item label="安全设备" prop="safetyEquipment">
          <el-input v-model="form.safetyEquipment" placeholder="请输入安全设备" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listShip, getShip, delShip, addShip, updateShip } from "@/api/system/ship";
import {checkLat, checkLon} from "@/api/system/rules";

export default {
  name: "Ship",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 【请填写功能名称】表格数据
      shipList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {

        pageNum: 1,
        pageSize: 10,
        shipName: null,
        shipType: null,
        lengthOverall: null,
        safetyEquipment:null,
        propulsion:null,
        registrationNumber: null,
        quantity: null,
        passengerCapacity: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        shipName: [
          { required: true, message: "船名不能为空", trigger: "chablurnge" },
        ],
        registrationNumber: [
          { required: true, message: "船舶注册号不能为空", trigger: "blur" },
        ],
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询游船列表 */
    getList() {
      this.loading = true;
      listShip(this.queryParams).then(response => {
        this.shipList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        shipName: null,
        shipType: null,
        lengthOverall: null,
        propulsion:null,
        safetyEquipment:null,
        registrationNumber: null,
        quantity: null,
        passengerCapacity: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    handleJump(row) {
      console.log("row",row)
      this.$router.push({ path: 'shipMapping', query: { id: row.registrationNumber } });
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "新增游船";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getShip(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改游船";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateShip(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addShip(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除该游船').then(function() {
        return delShip(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },



    /** 导出按钮操作 */
    handleExport() {
      this.download('system/ship/export', {
        ...this.queryParams
      }, `ship_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
